/*
 * Core modules for the IBM OSS Distributed Lock Manager
 *
 * Copyright (C) 2001, International Business Machines
 *
 * Authors: Peter R. Badovinatz, Ian D. Romanick
 * Contacts: wombat@us.ibm.com, romanick@us.ibm.com
 * http://oss.software.ibm.com/developerworks/opensource/linux/projects/dlm
 *
 * This program is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY;  without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program;  if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef CCCP_PKT_H
#define CCCP_PKT_H

#include <asm/types.h>

#ident "$Id: cccp_pkt.h,v 1.2 2001/04/04 19:12:08 idr Exp $"

#define DEF_BIT_AND_MASK(n,b) \
	CPB_ ## n = (b), \
	CPF_ ## n = (1UL << b)

enum
{
    DEF_BIT_AND_MASK( BROADCAST, 0 ),
    DEF_BIT_AND_MASK( REDIR_VALID, 1 ),
    DEF_BIT_AND_MASK( MSG_PRESENT, 2 ),
    DEF_BIT_AND_MASK( BLUE, 3 ),
    DEF_BIT_AND_MASK( NACK_VALID, 4 )
};

#define CCCP_VERSION	0x82

typedef struct clm_redir {
    __u16	cr_node;
    __u8	cr_port;
    __u8	cr_hops;
    __u8	cr_oldchan;
} clm_redir_t;

/* packet structure with added source node, longer session id */
typedef struct clm_pkt {
    __u8	cp_version;
    __u8	cp_flags;
    __u16       cp_header_length;

    __u8	cp_channel;
    __u8	cp_port;
    __u8	cp_prio;
    __u8	cp_hops;

    __u16	cp_node;
    __u16	cp_srcnode;

    long	cp_session;
    ulong	cp_acks;
    ulong	cp_type;
    ulong	cp_length;

    clm_redir_t	cp_redirect;
} clm_pkt_t;

#endif /* CCCP_PKT_H */
