/*
 * Core modules for the IBM OSS Distributed Lock Manager
 *
 * Copyright (C) 2001, International Business Machines
 *
 * Authors: Peter R. Badovinatz, Ian D. Romanick
 * Contacts: wombat@us.ibm.com, idr@us.ibm.com
 * http://oss.software.ibm.com/developerworks/opensource/linux/projects/dlm
 *
 * This program is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY;  without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program;  if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef CCCP_PROTO_H
#define CCCP_PROTO_H

#ident "$Id: cccp_proto.h,v 1.5 2001/04/04 19:19:30 idr Exp $"

#include <dlm.h>
#include "cccp_private.h"

struct cccp_node;
typedef struct cccp_node cccp_node_t;

/* PROJECT:	Cluster Lock Manager communications facility*/
/**/
/* MODULE:	protocol-specific grunge*/

extern void	initProto	( void );
extern int	queuePacket	( clm_msg_t *, clm_pkt_t *, uint );
extern void	handleRedirect	( cccp_node_t *, const clm_redir_t * );
extern int	handleAcks	( cccp_node_t *, u_int32_t );
extern void	queueRedirect	( clm_msg_t *, clm_pkt_t *, cccp_node_t *, uint );
extern void	queueAck	( cccp_node_t *, uint );
extern unsigned long doAckTimeouts( void );
extern cccp_node_t * updateNodeInfo( uint, cccp_sock_t );
extern void	openConnections	( void );
extern bool_t	checkRedirs	( cccp_node_t *, uint );
extern bool_t	checkSession	( cccp_node_t *, clm_pkt_t * );
extern cccp_node_t * cccpConn( uint );

extern bool_t checkDups( cccp_node_t *, ulong, uint );

extern void nackRetrans( cccp_node_t * node, ulong start, ulong got, 
			 ulong nacks );
extern int checkOrder( cccp_node_t * node, clm_pkt_t * pkt, clm_msg_t * msg );
extern void reOrder( cccp_node_t * node, uint sender );
extern void cccp_node_down( uint id, bool_t node_failed );
extern cccp_node_t * getNodeInfo( unsigned );

#endif /* CCCP_PROTO_H */
