/*
 * Core modules for the IBM OSS Distributed Lock Manager
 *
 * Copyright (C) 2001, International Business Machines
 *
 * Authors: Peter R. Badovinatz, Ian D. Romanick
 * Contacts: wombat@us.ibm.com, idr@us.ibm.com
 * http://oss.software.ibm.com/developerworks/opensource/linux/projects/dlm
 *
 * This program is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY;  without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program;  if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef CCCP_QUEUE_H
#define CCCP_QUEUE_H

#ident "$Id: cccp_queue.h,v 1.4 2001/07/31 23:48:24 idr Exp $"

/* PROJECT:	Cluster Lock Manager communications facility*/
/**/
/* MODULE:	queue handling*/

#include <dlm_list.h>

typedef int (queue_flush_func_t)( clm_msg_t *, clm_pkt_t *, void * );

extern void flushQueue( dlm_list_t * list, queue_flush_func_t * fp,
    uint prio );
extern void dumpQueue( dlm_list_t * list );
extern unsigned countQueue( dlm_list_t * list );

#endif /* CCCP_QUEUE_H */
