/*
 * Core modules for the IBM OSS Distributed Lock Manager
 *
 * Copyright (C) 2001, International Business Machines
 *
 * Authors: Peter R. Badovinatz, Ian D. Romanick
 * Contacts: wombat@us.ibm.com, idr@us.ibm.com
 * http://oss.software.ibm.com/developerworks/opensource/linux/projects/dlm
 *
 * This program is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY;  without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program;  if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef DLM_CLUST_H
#define DLM_CLUST_H

#ident "$Id: dlm_clust.h,v 1.3 2001/10/19 22:42:07 idr Exp $"

struct node_item
{
    int nodeid ;      /* cluster wide node ID */
    struct in_addr saddr ;    /* service address (one to use now) */
    int version ;     /* cluster version number */
#ifdef CONFIG_PROC_FS
    struct proc_dir_entry * proc_entry;
#endif /* CONFIG_PROC_FS */
};

struct node_list
{
    int low_version;
    int high_version;
    int node_count;
    struct node_item   node[ MAXNODES ];
} ;

extern struct node_list	* node_list;
extern struct node_list	* new_node_list;
extern int first_top_call;

#endif /* DLM_CLUST_H */
