/*
 * Core modules for the IBM OSS Distributed Lock Manager
 *
 * Copyright (C) 2001, International Business Machines
 *
 * Authors: Peter R. Badovinatz, Ian D. Romanick
 * Contacts: wombat@us.ibm.com, idr@us.ibm.com
 * http://oss.software.ibm.com/developerworks/opensource/linux/projects/dlm
 *
 * This program is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY;  without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program;  if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
#ident "$Id: ast_stub.h,v 1.4 2001/08/31 23:12:11 wombat Exp $"

/*
 *   COMPONENT_NAME: LIB
 *
 *   FUNCTIONS: none
 */
/*
 * This structure is passed across the syscall API, and so need to be defined
 * in both ast_stub.c and ast_kern.c.  -jjd-
 */

#ifndef AST_STUB_H
#define AST_STUB_H

/*
 * As a general catch-all in the core DLM code, we use this
 * to represent the function pointers that are carried around.
 */
typedef void (dlm_astfunc_t)( void *, int, void * );

#ifndef __KERNEL__

extern int ASTget( void * p );

#endif /* !__KERNEL__ */

typedef enum {
	AST_LOCK,
	AST_UNLOCK,
	AST_BADTYPE
} dlm_ast_t;

struct poll_info {
	dlm_ast_t	pi_type;
	dlm_astfunc_t * pi_func;
	void	      * pi_args;
	int		pi_mode;
	void	      * pi_extrap;
	dlm_stats_t	pi_status;
};

#endif /*  AST_STUB_H */
