/*
 * Core modules for the IBM OSS Distributed Lock Manager
 *
 * Copyright (C) 2001, International Business Machines
 *
 * Authors: Peter R. Badovinatz, Ian D. Romanick
 * Contacts: wombat@us.ibm.com, idr@us.ibm.com
 * http://oss.software.ibm.com/developerworks/opensource/linux/projects/dlm
 *
 * This program is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY;  without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program;  if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
#ident "$Id: clm_info.h,v 1.1.1.1 2001/02/14 20:58:05 wombat Exp $"

/*
 *   COMPONENT_NAME: INCCLUSTER
 *
 *   FUNCTIONS: none
 */

#ifndef CLM_INFO_H
#define CLM_INFO_H	1

#include "dlm.h"
#include "dlm_devmsg.h"

/*
 * this file contains structure definitions for cluster information that is
 * accessed by the communications layer and is managed by the lock manager
 * after being delivered from user space
 */

/* Max number of interface we'll believe could belong to one MDnode */
#define	MAXIFS		32

/*
 * This structure contains interface specific information that the lock
 * manager needs to do business.
 */
typedef struct clm_ifs {
	int			lifs_nodeid;
	struct sockaddr_in	lifs_addr;
	ulong			lifs_state;
	unsigned char	lifs_type;
} clm_ifs_t;

/*
 * This structure contains node specific information that the lock
 * manager needs to do business.
 */
typedef struct clm_node {
	int		cln_clusterid;	/* Cluster Id */
	int		cln_nodeid;	/* Cluster node Id */
	ulong		cln_md_state;	/* Cluster Node State */
	enum CLM_STATES	cln_clm_state;	/* Cluster Lock Manager State */
	int		cln_nif;        /* Cluster Node Number of Interfaces */
} clm_node_t;

#endif /* CLM_INFO_H */
