/*
 * Core modules for the IBM OSS Distributed Lock Manager
 *
 * Copyright (C) 2001, International Business Machines
 *
 * Authors: Peter R. Badovinatz, Ian D. Romanick
 * Contacts: wombat@us.ibm.com, idr@us.ibm.com
 * http://oss.software.ibm.com/developerworks/opensource/linux/projects/dlm
 *
 * This program is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY;  without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program;  if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
#ident "$Id: clm_locksw.h,v 1.4 2001/09/25 23:14:48 idr Exp $"

/*
 *   COMPONENT_NAME: CLLOCKD
 *
 *   FUNCTIONS: none
 */
#ifndef LOCKSW_H
#define LOCKSW_H

#ifdef __KERNEL__
#include <linux/signal.h>
#include <linux/errno.h>
#include <linux/types.h>
#endif /*  __KERNEL__ */

#include "dlm.h"
#include "clmstructs.h"

struct locksw {
  dlm_stats_t	(*master_lock)(clm_msg_t *, int);
  int 		(*begin_lock)(clm_trans_t *);
  void 		(*cont_lock)(struct transaction *,
                         struct transaction *);
  dlm_stats_t	(*master_unlock)(clm_msg_t *);
  int 		(*begin_unlock)(clm_trans_t *);
  void 		(*cont_unlock)(clm_trans_t *,
                           clm_trans_t *);
  void		(*wakeup)(struct resource *,
                      struct reclock *);
  void		(*purge)(struct resource *,
                     dlm_list_t *,
                     struct reclock *);
};
extern const struct locksw lockswitch[DLM_RES_NTYPES];

#endif /* defined LOCKSW_H */
