/*
 * Core modules for the IBM OSS Distributed Lock Manager
 *
 * Copyright (C) 2001, International Business Machines
 *
 * Authors: Peter R. Badovinatz, Ian D. Romanick
 * Contacts: wombat@us.ibm.com, idr@us.ibm.com
 * http://oss.software.ibm.com/developerworks/opensource/linux/projects/dlm
 *
 * This program is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY;  without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program;  if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
#ident "$Id: dlm_version.h,v 1.1.1.1 2001/02/14 20:58:08 wombat Exp $"

/*
 * Distributed Lock Manager for Linux - version information
 *
 * For now, simple defines to identify code updates, not to
 * specifically match the Linux kernel/module versioning.
 */

#ifndef DLM_VERSION_H
#define DLM_VERSION_H

/*
 | Lock manager version numbers.  These version numbers are embedded
 | in the messages notifying the lock manager of lock manager state
 | changes.
 */
#define DLM_MAJOR_VERSION 0
#define DLM_MINOR_VERSION 1

/*
 * Migration protocol
 */
#define MPROTO_VERSION 1

/*
 * Current version
 */
#define DLM_00000001VERSION ((DLM_MAJOR_VERSION << 16) |  \
                             (DLM_MINOR_VERSION & 0xffff))

#define DLM_FIRST_VERSION DLM_00000001VERSION

#define DLM_CurVERSION DLM_00000001VERSION

/* version of *this* copy of the software */
#define DLM_VERSION     DLM_CurVERSION

#endif /* DLM_VERSION_H */
