/*
 * Core modules for the IBM OSS Distributed Lock Manager
 *
 * Copyright (C) 2001, International Business Machines
 *
 * Authors: Peter R. Badovinatz, Ian D. Romanick
 * Contacts: wombat@us.ibm.com, idr@us.ibm.com
 * http://oss.software.ibm.com/developerworks/opensource/linux/projects/dlm
 *
 * This program is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY;  without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program;  if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
#ident "$Id: pti.h,v 1.2 2001/07/31 23:55:06 idr Exp $"

/*
 *   COMPONENT_NAME: DLM
 *
 *   FUNCTIONS: defined
 */

#if !defined(PTI_H) 
#define PTI_H

/*
 * pti.h - This file contains all the structures and #defines for
 * the Primary Transaction Interface function of the cluster lock manager.
 */

#define PTI_PROG 	20005010
#define PTI_VERS 	1
#define LM_MAXSTRLEN	1024

/*
 * state flags for cllockd
 */

#define CLM_ACTIVE		0x1
#define PTI_ACTIVE		0x2
#define RECONFIG		0x4
#define DUMPING_TO_PRIMARY	0x8
#define DUMPING_TO_INFO		0x10
#define REQUEST_DUMP		0x20	/* primary waiting for locks */
#define LOCKSTALL		0x40	


struct Dump_State {
	int site; 
	bool_t receiving;
	int	retry;
};
typedef struct Dump_State Dump_State;


struct pti_notify {
	char *name;
	long state;
};
typedef struct pti_notify pti_notify;


#define MAXDUMPCNT 200

struct dumptable {
   int cnt;
   struct lockinfo locks[MAXDUMPCNT];
};


#endif /* !defined(PTI_H) */
